/*
 * testing_hooks.hpp
 *
 *  Created on: 28.05.2008
 *      Author: maik
 */

#ifndef TESTING_HOOKS_HPP_
#define TESTING_HOOKS_HPP_

#include <cstdio>
#include <cstdlib>

namespace myapp { 
 
  
namespace /*anonym*/ {  

  int num_test_errors = 0;
   
  struct errors_reporter 
  {
    ~errors_reporter() 
    {
      using namespace std;
      if(num_test_errors)
        printf("this is mypapp testing suite: %d errors occured\n", num_test_errors);
    }
  } e_reporter;

} // namespace anonym 


static inline 
void report_check_failed(char const* text, char const* filename, int line)
{
  using namespace std;
  num_test_errors++; \
  fprintf(stderr, "myapp testing error: %s in file %s:%d\n", text, filename, line);
}

static inline 
void report_requirement_failed(char const* text, char const* filename, int line)
{
  using namespace std;
  num_test_errors++; \
  fprintf(stderr, "myapp testing requirement failed: %s in file %s:%d\nexit now!\n",
          text, filename, line);
  exit(1); 
}


#define MYAPP_CHECK(expr) \
  if(true) \
  { \
    if( !(expr) )\
    { \
      ::myapp::report_check_failed(#expr, __FILE__, __LINE__); \
    } \
  } \
  else \
    (void)0

#define MYAPP_REQUIRE(expr) \
  if(true) \
  { \
    if( !(expr) ) \
    { \
      using namespace std; \
      \
      ::myapp::report_requirement_failed(#expr, __FILE__, __LINE__); \
    } \
  } \
  else \
    (void)0



} // namespace foo


#endif /* TESTING_HOOKS_HPP_ */
