/*
 * exceptions.hpp
 *
 *  Created on: 28.05.2008
 *      Author: maik
 */
 
#ifndef EXCEPTIONS_HPP_
#define EXCEPTIONS_HPP_


#include <testhooks/errors.hpp>
#include <exception>
#include <string>

namespace myapp {


#define MYAPP_HANDLE(e) \
  if(true) \
  { \
    std::string msg = "myapp testing: an exception occured\n what: "; \
    msg += e.what(); \
    msg += "\nexit now!\n" ;\
    ::myapp::report_check_failed(msg.c_str(), __FILE__, __LINE__); \
  } \
  else \
    (void)0

#define MYAPP_HANDLE_UNEXPECTED \
  if(true) \
  { \
    ::myapp::report_check_failed("only std::exception are allowed!", \
                                 __FILE__, __LINE__); \
  } \
  else \
    (void)0

  
#define MYAPP_CHECK_WILL_THROW(expr) \
  if(true) \
  { \
    bool throwed = false; \
    \
    try { (expr) ; } \
    catch(...) {  throwed = true; } \
    \
    if(!throwed) \
    { \
      ::myapp::report_check_failed("only std::exception is allowed to be thrown!", \
                                   __FILE__, __LINE__); \
    } \
  } \
  else \
    (void)0

#define MYAPP_REQUIRE_WILL_THROW(expr) \
  if(true) \
  { \
    bool throwed = false; \
    \
    try { (expr) ; } \
    catch(...) {  throwed = true; } \
    \
    if(!throwed) \
    { \
      ::myapp::report_requirement_failed("only std::exception is allowed to be thrown!", \
                                         __FILE__, __LINE__); \
    } \
  } \
  else \
    (void)0


#define MYAPP_CHECK_WONT_THROW(expr) \
  if(true) \
  { \
    bool throwed = false; \
    \
    try { (expr) ; } \
    catch(...) { throwed = true; } \
    \
    if(throwed) \
    { \
      std::string msg = #expr; \
      msg += " wasn't expected to throw"; \
      ::myapp::report_check_failed(msg.c_str(), __FILE__, __LINE__); \
    } \
  } \
  else \
    (void)0

#define MYAPP_REQUIRE_WONT_THROW(expr) \
  if(true) \
  { \
    bool throwed = false; \
    \
    try { (expr) ; } \
    catch(...) { throwed = true; } \
    \
    if(throwed) \
    { \
      std::string msg = #expr; \
      msg += " wasn't expected to throw"; \
      ::myapp::report_requirement_failed(msg.c_str(), __FILE__, __LINE__); \
    } \
  } \
  else \
    (void)0


  
} // namespace myapp  
  
#endif /* EXCEPTIONS_HPP_ */
